<script setup>
// imports
import { ref } from "vue";

//  state variables
let todoList = ref([]);
let todo = ref(null);
let selectedTodo = ref(null);

// function for selecting row to be edited/updated
const selectTodo = (row) => {
  selectedTodo.value = row;
  todo.value = row.todo;
};

// function for adding new todo task
const addTodo = () => {
  // check first if the task already exist in todo list before insert
  if (validateTodo(todo.value)) {
    let id = todoList.value.length;
    // insert task to the list
    todoList.value.push({
      id: ++id,
      todo: todo.value,
      is_done: false,
    });
    todo.value = null;
  }
};

// function for checking/validating existing todo task in todo list
const validateTodo = (new_todo) => {
  // check if the new todo task is in the todo list by finding the index
  let index = todoList.value.findIndex((t) => t.todo === new_todo);
  if (index !== -1) {
    alert("Todo already exist!");
    return false;
  } else {
    return true;
  }
};

// function for editing/updating the selected todo task in the todo list
const updateTodo = () => {
  if (validateTodo(todo.value)) {
    let index = todoList.value.findIndex((t) => t.id === selectedTodo.value.id);
    index !== -1 && (todoList.value[index].todo = todo.value);

    todo.value = selectedTodo.value = null;
  }
};

// function for marking individual todo task as done
const markAsDone = (row) => {
  // display confirmation message first
  if (confirm(`Are you sure you want to mark ${row.todo} as done?`)) {
    let index = todoList.value.findIndex((t) => t.id === row.id);
    // changes is_done to true
    index !== -1 && (todoList.value[index].is_done = true);
  }
};

// function for removing individual todo task
const removeTodo = (row) => {
  // display confirmation message first
  if (confirm(`Are you sure you want to delete ${row.todo}?`)) {
    let index = todoList.value.findIndex((t) => t.id === row.id);
    // remove the todo in the todoList array using splice
    index !== -1 && todoList.value.splice(index, 1);
  }
};
</script>

<template>
  <main class="d-flex justify-content-center container">
    <div class="w-75">
      <!-- Form for adding/updating todo task  -->
      <form @submit.prevent="!selectedTodo ? addTodo() : updateTodo()">
        <div class="mb-3 mt-5">
          <label for="todo">What's your todo?</label>
          <div class="d-flex">
            <!-- todo input -->
            <input
              v-model="todo"
              type="text"
              class="form-control"
              id="todo"
              placeholder="eg. Create todo application"
            />

            <!-- show add btn if selectedTodo is null -->
            <button v-if="!selectedTodo" class="btn btn-primary ms-3">
              <i class="bi bi-plus-circle-fill"></i>
            </button>

            <!-- show edit btn if selectedTodo is not null -->
            <button v-else class="btn btn-primary ms-3">
              <i class="bi bi-pencil-square"></i>
            </button>
          </div>
        </div>
      </form>

      <!-- Todo Task List Display -->
      <div
        @click="selectTodo(row)"
        v-for="row in todoList"
        :key="row.id"
        class="toast show mt-2 w-100"
      >
        <div class="toast-header">
          <!-- Todo description -->
          <strong class="me-auto">{{ row.todo }}</strong>

          <!-- Check Btn -->
          <button
            :class="`btn btn-${
              row.is_done ? 'success text-light' : 'outline-secondary'
            } btn-sm`"
            @click.stop="markAsDone(row)"
            class="btn btn-sm"
          >
            <i class="bi bi-check-lg"></i>
          </button>

          <!-- Remove Btn -->
          <button
            @click.stop="removeTodo(row)"
            class="btn btn-danger btn-sm ms-1"
          >
            <i class="bi bi-trash-fill"></i>
          </button>
        </div>
      </div>
    </div>
  </main>
</template>

<style scoped></style>
